# LinkAhead Sample Management Module

This module contains the custom code for sample management like it is
used in GEOMAR's [Biosample Information System
BIS](https://biosamples.geomar.de/).

## Usage

**TODO**: Add explanations, screenshots, ec. to explain the sample
management from a **user** perspective. There is an upload of a
presentation showing the usage in the context of BIS on Zenodo:
https://doi.org/10.5281/zenodo.14056085.

## Setup

Add the `sample-management-custom` directory to the list of custom
directories in your LinkAhead profile.yml. You'll need to set up
[server-side
scripting](https://docs.indiscale.com/caosdb-deploy/server_side_scripting.html)
and give the permissions (`SCRIPTING:EXECUTE:<script_name>`) for the
scripts in `sample-management-custom/caosdb-server/scripting/bin/` to
the desired users and groups. You may also want to add a custom
authentication token configuration so that the registration and or
upload scripts are executed with special permissions.

Add the data model from
`models_and_helper_scripts/sample-management-model.yml` to your
instance's data model (e.g., by [synchronizing with the LinkAhead
advanced user
tools](https://docs.indiscale.com//caosdb-advanced-user-tools/yaml_interface.html)).

## Customization

The sample management module can be customized by overwriting
indivdual code and config files by using files of the same name and
with the same relative path in your LinkAhead profile's custom
directory.  E.g., if you want to overwrite how sample entities are post-processed in the sample upload, you overwrite

```
sample-management-custom/caosdb-server/scripting/bin/sample_helpers/sample_upload_post_processing.py
```

from this repository by a

```
profile/custom/caosdb-server/scripting/bin/sample_helpers/sample_upload_post_processing.py
```

in your server profile. When doing so, it is important that in your
custom file, you use the exact same function names, signatures, and
return types as in the original file. In our example, the custom
`sample_upload_post_processing.py` needs to contain a
`post_process_samples` that takes the samples and the csv data as
arguments and returns the list of post processed samples.


## Testing

There is a pre-configured `test-profile` that you can use for testing
this repository.

## Further Reading

Please refer to the [official documentation](https://docs.indiscale.com/caosdb-deploy/) for more information.

## Contributing

Thank you very much to all contributers—[past, present](https://gitlab.com/linkahead/linkahead-meta/-/blob/dev/HUMANS.md), and prospective ones.

### Code of Conduct

By participating, you are expected to uphold our [Code of Conduct](https://gitlab.com/linkahead/linkahead-meta/-/blob/dev/CODE_OF_CONDUCT.md).

### How to Contribute

* You found a bug, have a question, or want to request a feature? Please
[create an issue](https://gitlab.indiscale.com/caosdb/src/linkahead-sample-management/-/issues).
* You want to contribute code? Please fork the repository and create a merge
request in GitLab and choose this repository as target. Make sure to select
"Allow commits from members who can merge the target branch" under Contribution
when creating the merge request. This allows our team to work with you on your request.
- You can also contact us at **info (AT) indiscale.com**  and join the
  LinkAhead community on
  [#linkahead:matrix.org](https://matrix.to/#/!unwwlTfOznjEnMMXxf:matrix.org).

## License

* Copyright (C) 2024 Indiscale GmbH <info@indiscale.com>

All files in this repository are licensed under a [GNU Affero General Public
License](LICENCE.md) (version 3 or later).
